//
//  Command.hpp
//  gtk_channels
//
//  Created by Arnaud Blanchard on 21/10/2019.
//

#ifndef Command_hpp
#define Command_hpp

#include <string>
#include <vector>
#include "Process.h"
#include "blc_channel.h"

/* One command may have many processes */
struct Command{
    std::string binary;
    std::string program_name;
    std::function<bool(std::vector<blc_channel const*> &channels)> valid_channels;
    std::vector<const char *> args;
    
    Command(std::string const &bin_dir, std::string program_name, std::initializer_list<char const*> default_args, std::function<bool(std::vector<blc_channel const*>)>validity);
    Command(Command const &command, std::vector<blc_channel const*> const channel); //Copy command and add arguments

    void add_args(std::initializer_list<char const *> optional_args);
    std::unique_ptr<Process> execute(std::function<void(Process*)> after_launch) const;
};

#endif /* Command_hpp */
